
#  getfile is just a directory browser.  It's been done much
#  better many times before but I wanted to maintain the same
#  look and feel as other windows.
#
# Come here when the user presses Button 1 in the directory listing
proc getfile_b1_dir { win } {

	set idx [$win.dir curselection]
	set dir [$win.dir get $idx]
	cd $dir
	return [getfile_dir $win ]
}

# Come here when the user presses Button 1 in the directory listing
proc getfile_b1_file { win } {
	global news

	set idx [$win.file curselection]
	set news(GetFile,file) [$win.file get $idx]
}

proc getfile_dir { win {dir ""} } {
	global news 
	
	# set news(GetFile,file) ""
	if { $dir == "" } {
		set dir [pwd]
	}
	set news(GetFile,dir) $dir
	$win.file delete 0 end
	$win.dir delete 0 end
	$win.dir insert end "."
	$win.dir insert end ".."
	foreach f [lsort [glob -nocomplain $dir/$news(.getfile,mask) ] ] { 
		if { [file isdirectory $f] } {
			$win.dir insert end [file tail $f]
		} else {
			$win.file insert end [file tail $f]
		}
	}
}

proc getfile { {filename "" } } {
	global news

	if { $filename != "" } {
		set news(GetFile,file) $filename
	}
	if { ![info exists news(GetFile,file)] } {
		set news(GetFile,file) ""
	}

	set old $news(GetFile,file)
	set curdir $news(personal)

	if { ![info exists news(GetFile,dir)] } {
		 set news(GetFile,dir) $curdir
	}

	if { $news(GetFile,file) != "" && [file dirname $news(GetFile,file)] != "." } {
		set news(GetFile,dir) [file dirname $news(GetFile,file)]
		set news(GetFile,file) [file tail $news(GetFile,file)]
	}

	catch { cd $news(GetFile,dir) }

	set win .getfile
	window $win TkGetFile TkGetFile listbox OK Cancel MkDir 
	destroy $win.uf

	set news(GetFile,wait) 0
	$win.ok configure -command "set news(GetFile,wait) 1"
	$win.cancel configure -command "set news(GetFile,wait) 2"
	$win.mkdir configure -text "Create Dir" -command { catch { 
			global news
			if { [catch {file mkdir $news(GetFile,dir)} msg] == 1 } {
				tk_dialog .me "$news(tclnews) $news(version)" "Can't create $news(GetFile,dir)!\n$msg" error 0 OK
				return
			} 	
			cd $news(GetFile,dir) 
			getfile_dir $news(GetFile,win) 
		}  
	}

	#The window function is not quit right for this so I'll fudge it
	set type listbox
	set news(GetFile,win) $win.f1.f4.f3
	set w $win.f1.f4.f3
	destroy $w ; # Get rid of the existing widgets then create some new ones;


	frame $w -borderwidth 2 -relief raised -width 50
	frame $win.uf
	#  Create a space to show the current directory & selected file
	frame $win.uf.f
	label $win.uf.l -text "Directory:"
	entry $win.uf.dir -textvariable news(GetFile,dir)
	pack  $win.uf.l    -in $win.uf.f -anchor w -expand 0 -ipadx 0 -ipady 0 -padx 0 -pady 0 -side left
	pack  $win.uf.dir -in $win.uf.f -anchor w -expand 1 -fill x -ipadx 0 -ipady 0 -padx 0 -pady 0 -side left
	pack  $win.uf.f -anchor w -expand 1 -fill x -ipadx 0 -ipady 0 -padx 0 -pady 0 -side top
	bind  $win.uf.dir <Return> { catch { 
			global news
			if { ![file isdirectory $news(GetFile,dir)] } {
				if { [tk_dialog .me "$news(tclnews) $news(version)" "$news(GetFile,dir) does not exist!!!\nCreate it now?" error 0 OK CANCEL] == 0 } {
					if { [catch {file mkdir $news(GetFile,dir)} msg] == 1 } {
						tk_dialog .me "$news(tclnews) $news(version)" "Can't create $news(GetFile,dir)!\n$msg" error 0 OK
						return
					} 	
				} else {
					return
				}
			}
			cd $news(GetFile,dir) 
			getfile_dir $news(GetFile,win) 
		}  
	}

	frame $win.uf.f1
	label $win.uf.l1 -text "File:"
	entry $win.uf.file -textvariable news(GetFile,file)
	bind $win.uf.file <Return> { set news(GetFile,wait) 1 }
	pack  $win.uf.l1    -in $win.uf.f1 -anchor w -expand 0 -ipadx 0 -ipady 0 -padx 0 -pady 0 -side left
	pack  $win.uf.file -in $win.uf.f1 -anchor w -expand 1 -fill x -ipadx 0 -ipady 0 -padx 0 -pady 0 -side left
	pack  $win.uf.f1 -anchor w -expand 1 -fill x -ipadx 0 -ipady 0 -padx 0 -pady 0 -side top
	pack  $win.uf -in $win.f1.f4 -anchor w -expand 0 -fill x -ipadx 0 -ipady 0 -padx 0 -pady 0  -side top

	# Build the left frame for the directory listing
	frame $w.lf   -relief sunken -borderwidth 2
	frame $w.lf.f1
	listbox $w.dir -height 1 -background $news(bg) -foreground $news(fg) -width 1 -font -*-fixed-bold-r-normal--13-* -relief flat \
		-xscrollcommand "$w.dirsx set" \
		-yscrollcommand "$w.dirsy set"
	scrollbar $w.dirsx  -command "$w.dir xview" -orient horizontal
	scrollbar $w.dirsy  -command "$w.dir yview" 
	# $w.dir configure -selectmode extended
	bind $w.dir <Double-1> "getfile_b1_dir $w"
	bind $w.dir <3> "getfile_b1_dir $w"
	pack $w.dir    -in $w.lf.f1 -anchor w -expand 1 -fill both -ipadx 0 -ipady 0 -padx 0 -pady 0 -side left
	pack $w.dirsy -in $w.lf.f1 -anchor center -expand 0 -fill y -ipadx 0 -ipady 0 -padx 5 -pady 5 -side right
	pack $w.lf.f1  -in $w.lf  -anchor w -expand 1 -fill both -ipadx 0 -ipady 0 -padx 0 -pady 0 -side top
	pack $w.dirsx -in $w.lf -anchor center -expand 0 -fill both -ipadx 0 -ipady 0 -padx 5 -pady 5 -side bottom
	pack $w.lf     -in $w        -anchor w -expand 1 -fill both -ipadx 0 -ipady 0 -padx 0 -pady 0 -side left

	# ==================================================
	# Build the right frame for the file listing
	frame $w.rf   -relief sunken -borderwidth 2
	frame $w.rf.f1
	listbox $w.file -height 1 -background $news(bg) -foreground $news(fg) -width 1 -font -*-fixed-bold-r-normal--13-* -relief flat \
		-xscrollcommand "$w.filesx set" \
		-yscrollcommand "$w.filesy set"
	scrollbar $w.filesx  -command "$w.file xview" -orient horizontal
	scrollbar $w.filesy  -command "$w.file yview" 
	# $w.file configure -selectmode extended
	bind $w.file <Double-1> "getfile_b1_file $w"
	bind $w.file <3> "getfile_b1_file $w"
	pack $w.file    -in $w.rf.f1 -anchor w -expand 1 -fill both -ipadx 0 -ipady 0 -padx 0 -pady 0 -side left
	pack $w.filesy -in $w.rf.f1 -anchor center -expand 0 -fill y -ipadx 0 -ipady 0 -padx 5 -pady 5 -side right
	pack $w.rf.f1  -in $w.rf  -anchor w -expand 1 -fill both -ipadx 0 -ipady 0 -padx 0 -pady 0 -side top
	pack $w.filesx -in $w.rf -anchor center -expand 0 -fill both -ipadx 0 -ipady 0 -padx 5 -pady 5 -side bottom
	pack $w.rf     -in $w        -anchor w -expand 1 -fill both -ipadx 0 -ipady 0 -padx 0 -pady 0 -side left
	# ===============================================

	pack $w -expand yes -fill both

	#  Set the search button to be a rescan button
	set news($win,mask) "*"
	$win.f1.f5.b configure -text "Re Scan" -command "getfile_dir $w"

	

	getfile_dir $w

	focus $win.uf.file 
	grab $win
	tkwait variable news(GetFile,wait)

	catch { cd $curdir }
	closewin getfile
	if { $news(GetFile,wait) == 1 && $news(GetFile,file) != "" } {
		return "$news(GetFile,dir)/$news(GetFile,file)"
	} else {
		set news(GetFile,file) $old
		return "" ; # Canceled
	}
}

# I'm not using the tk_SaveFile becouse I want to be able to 
# create a directory to save in.
proc getfile_news { {filename "" } } {
	global news

	if { $filename != "" } {
		set news(GetFile,dir) [file dirname $filename]
		set news(GetFile,file) [file tail $filename]
	} else {
		set news(GetFile,dir) $news(personal)
		set news(GetFile,file) ""
	}
	return [tk_getSaveFile -initialdir "$news(GetFile,dir)" -initialfile "$news(GetFile,file)" ]
}
